﻿@using Microsoft.AspNetCore.Identity
@using SocialMedia.Models
@using SocialMedia.Web.Models
@using SocialMedia.Services.Contracts
@using SocialMedia.Web.Mapper;

@inject IFriendRequestService _friendRequestService
@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{
    IEnumerable<FriendRequestViewModel> outgoingRequests;
    IEnumerable<FriendRequestViewModel> incomingRequests;

    if (int.TryParse(UserManager.GetUserId(User), out int userId))
    {
        outgoingRequests = (await _friendRequestService.GetOutgoingRequests(userId))
            .Select(x => x.ToViewModel());
        incomingRequests = (await _friendRequestService.GetIncomingRequests(userId))
            .Select(x => x.ToViewModel());
    }
    else
    {
        outgoingRequests = new FriendRequestViewModel[0];
        incomingRequests = new FriendRequestViewModel[0];
    }
}

@if (SignInManager.IsSignedIn(User))
{
<ul class="setting-area">
    @if (User.IsInRole("Admin"))
    {
        <li><a href="" onclick="redirectToAdmin()" title="Admin" data-toggle="tooltip" data-placement="bottom"><i class="ti-credit-card"></i></a></li>
    }
    <li>
        <a href="#" title="Find" data-toggle="tooltip" data-placement="bottom"><i class="ti-search"></i></a>
        <div class="searched">
            <form method="post" class="form-search">
                <input type="text" placeholder="Find Friend" onkeypress='handle(event, "/User/Search?searchQuery=" + this.value)'>
            </form>
        </div>
    </li>
    <li><a href="" onclick="redirectToHome()" title="Home" data-toggle="tooltip" data-placement="bottom"><i class="ti-home"></i></a></li>
    <li><a href="" onclick="redirectToFriends()" title="Friends" data-toggle="tooltip" data-placement="bottom"><i class="ti-user"></i></a></li>
    <li><a href="" onclick="redirectToAPI()" title="API" data-toggle="tooltip" data-placement="bottom"><i class="ti-settings"></i></a></li>

    <li>
        <a href="#" title="Incoming Requests" data-toggle="tooltip" data-placement="bottom" data-ripple="">
            <i class="ti-angle-double-down"></i><span>@incomingRequests.Count()</span>
        </a>
        <div class="dropdowns">
            <span>Incoming Requests</span>
            @foreach (FriendRequestViewModel fr in incomingRequests)
            {
                int elapsedMinutes = (int)(DateTime.Now - fr.CreatedOn).TotalMinutes;
                <ul class="drops-menu">
                    <li>
                        <a href="" onclick="redirectToFriends()">
                            <img src="@Url.Action("GetImage", "Home", new { userId = fr.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                            <div class="mesg-meta">
                                <h6>from @fr.SenderFullName</h6>
                                <span>@fr.RequestBody</span>
                                <i>@(elapsedMinutes)min ago</i>
                            </div>
                        </a>
                        @if (elapsedMinutes < 60)
                        {
                            <span class="tag green">New</span>
                        }
                    </li>
                </ul>
            }
        </div>
    </li>
    <li>
        <a href="" title="Outgoing Requests" data-toggle="tooltip" data-placement="bottom" data-ripple="">
            <i class="ti-angle-double-up"></i><span>@outgoingRequests.Count()</span>
        </a>
        <div class="dropdowns">
            <span>Outgoing Requests</span>
            @foreach (FriendRequestViewModel fr in outgoingRequests)
            {
                int elapsedMinutes = (int)(DateTime.Now - fr.CreatedOn).TotalMinutes;
                <ul class="drops-menu">
                    <li>
                        <a href="" onclick="redirectToFriends()">
                            <img src="@Url.Action("GetImage", "Home", new { userId = fr.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                            <div class="mesg-meta">
                                <h6>to @fr.ReceiverFullName</h6>
                                <span>@fr.RequestBody</span>
                                <i>@(elapsedMinutes)min ago</i>
                            </div>
                        </a>
                        @if (elapsedMinutes < 60)
                        {
                            <span class="tag green">New</span>
                        }
                    </li>
                </ul>
            }
        </div>
    </li>
</ul>
    <div class="user-img">
        <img src="@Url.Action("GetImage", "Home", new { userId = userId})" onerror='this.src="/images/profile-icon.png"' alt="" width="60" height="60">
        <div class="user-setting">
            <a onclick="redirectToProfile(@userId)" title=""><i class="ti-user"></i>Profile</a>
            <a onclick="redirectToSettings()" title=""><i class="ti-settings"></i>Settings</a>
            <a id="usrMenuLogout" onclick="logoutSubmit()"><i class="ti-power-off"></i>Log Out</a>
            <script>
                function logoutSubmit() {
                    document.getElementById('logoutForm').submit();
                }
            </script>
            <form type="hidden" id="logoutForm" class="form-inline" asp-area="Identity" asp-page="/Account/Logout" asp-route-returnUrl="@Url.Action("Index", "Home", new { area = "" })">
            </form>
        </div>
    </div>
}
else
{
    <div class="login-form">
        <form>
            <button asp-controller="Home" asp-action="Index">Login</button>
        </form>
    </div>
}
